package com.qfs.pagan

import android.content.Context
import android.util.AttributeSet
import android.view.ContextThemeWrapper
import androidx.appcompat.content.res.AppCompatResources


class ButtonIcon(context: Context, attrs: AttributeSet? = null): androidx.appcompat.widget.AppCompatImageView(context, attrs) {
    init {
        this.background = AppCompatResources.getDrawable(context, R.drawable.button_icon)
    }
    // NOTE: this logic exists in drawableStateChanged() rather than init since palette isn't guaranteed
    // to exist on init()
    override fun drawableStateChanged() {
        super.drawableStateChanged()
        var context = this.context
        while (context !is MainActivity) {
            context = (context as ContextThemeWrapper).baseContext
        }

        //val color_map = context.view_model.color_map
        //val index = (this.background as StateListDrawable).findStateDrawableIndex(this.drawableState)
        //val background = ((this.background as StateListDrawable).getStateDrawable(index) as LayerDrawable).findDrawableByLayerId(R.id.tintable_background)
        //background?.setTint(color_map[Palette.Button])
        //this.setColorFilter(color_map[Palette.ButtonText])
        this.alpha = if (this.isEnabled) {
            1f
        } else {
            .5f
        }
    }
}